function varargout = Jacobi_appr(fun,x,lsq, varargin)
%Approximation of the Jacobi Matrix using forward differences
%Allocate Jacobi matrix
paramdim = length(x);
datadim = length(lsq);
J = zeros(datadim ,paramdim );
%Default stepsize
step = 1e-7;
%Static parameter
p = x;
for  i = 1 : paramdim
    if  x(i) == 0
        p(i) = step^2;
    else
        p(i) = x(i) + step*abs(x(i));
    end
    ret = feval(fun,p);
    J(:,i) = (ret - lsq)/(p(i) - x(i));
    p(i) = x(i);
end
varargout{1} = J';
varargout{2} = J'*J;