function options = define_algorithm_options(algor, iterations,functiontol,verbose)
%Define the options for lsq-curvefit or fmincon
if algor ==0
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'Algorithm','trust-region-reflective','UseParallel','never');
elseif algor ==1
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'Algorithm',{'levenberg-marquardt',.002},'UseParallel','never');
elseif algor ==2
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'Algorithm','active-set','UseParallel','never');
elseif algor ==3
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'Algorithm','interior-point','UseParallel','never');
elseif algor ==4
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'Algorithm','sqp','UseParallel','never');
elseif algor ==5
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'UseParallel','never');
elseif algor ==6
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'UseParallel','never');
elseif algor ==7
    options = optimset('MaxIter', iterations, 'TolFun', functiontol,...
        'MaxFunEvals', 15000,'Display', verbose,'UseParallel','never');
end


