%Convert structure elements in one data vector for optimization
function [startpoints,bounderies] = generateOptVector(Sys,Vary,Sysst,Exp,Expsst, FitOpt)

%Loop for allocation of the parameter vector
nnn=0;

for spinSys = 1:length(Vary)
    Vary_tmp_nnn = struct2cell(Vary{spinSys});
    for k = 1:length(Vary_tmp_nnn)
        size_tmp = size(Vary_tmp_nnn{k});
        nnn=nnn+size_tmp(1)*size_tmp(2);
    end
end

%Allolcate the starting point and boudary vector
startpoints = zeros(nnn,1);
bounderies = zeros(2,nnn);

m=0;
for spinSys = 1:length(Vary)
    Sys_tmp = Sys{spinSys};
    Vary_tmp = Vary{spinSys};
    Sysst_tmp = Sysst{spinSys};
    nn=0;
    parameters = {'g','gFrame','AFrame','D', 'Q','QFrame', 'DFrame', ...
        'AStrain','lwEndor','HStrain','J','ee', 'eeD', 'nn','Abund', ...
        'gStrain','DStrain', 'weight','lwpp','lw','logtcorr'};
    for p = 1:length(parameters)
        if isfield(Vary_tmp,parameters{p})
            sA = size(Vary_tmp.(parameters{p}));
            if sA(1) == 1
                for n=1:(sA(1)*sA(2))
                    nn =nn+1;
                    startpoints(nn+m) = Sys_tmp.(parameters{p})(n);
                    bounderies(1,nn+m) = Sysst_tmp.(parameters{p})(n)-...
                        Vary_tmp.(parameters{p})(n);
                    bounderies(2,nn+m) = Sysst_tmp.(parameters{p})(n)+...
                        Vary_tmp.(parameters{p})(n);
                end
            elseif sA(1) > 1
                for n=1:sA(1)
                    for t=1:sA(2)
                        nn =nn+1;
                        startpoints(nn+m) =Sys_tmp.(parameters{p})(n,t);
                        bounderies(1,nn+m) = Sysst_tmp.(parameters{p})(n,t)-...
                            Vary_tmp.(parameters{p})(n,t);
                        bounderies(2,nn+m) = Sysst_tmp.(parameters{p})(n,t)+...
                            Vary_tmp.(parameters{p})(n,t);
                    end
                end
            end
        end
    end
    
    % Treat A different, due to the equivnuc option
    if isfield(Vary_tmp,'A')
        sA = size(Vary_tmp.A);
        if sA(1) == 1 &&  FitOpt.sameHFcoupling == false
            for n=1:(sA(1)*sA(2))
                nn =nn+1;
                startpoints(nn+m) = Sys_tmp.A(n);
                bounderies(1,nn+m) = Sysst_tmp.A(n)-Vary_tmp.A(n);
                bounderies(2,nn+m) = Sysst_tmp.A(n)+Vary_tmp.A(n);
            end
        elseif FitOpt.sameHFcoupling == true
            for t=1:sA(2)
                nn =nn+1;
                startpoints(nn+m) = Sys_tmp.A(1,t);
                bounderies(1,nn+m) = Sysst_tmp.A(1,t)-Vary_tmp.A(1,t);
                bounderies(2,nn+m) = Sysst_tmp.A(1,t)+Vary_tmp.A(1,t);
            end
        elseif  sA(1) > 1 && FitOpt.isequivHFcoupling == true
            C = unique(FitOpt.equivHFcoupling);
            C_len = length(C);
            ts = 1;
            for n=1:C_len
                s = sum(FitOpt.equivHFcoupling(:) == n);
                for t=1:(sA(2))
                    nn =nn+1;
                    startpoints(nn+m) = Sys_tmp.A(ts+s-1,t);
                    bounderies(1,nn+m) = Sysst_tmp.A(ts+s-1,t)-Vary_tmp.A(n,t);
                    bounderies(2,nn+m) = Sysst_tmp.A(ts+s-1,t)+Vary_tmp.A(n,t);
                end
                ts = ts+s;
            end
        elseif sA(1) > 1
            for n=1:sA(1)
                for t=1:sA(2)
                    nn =nn+1;
                    startpoints(nn+m) = Sys_tmp.A(n,t);
                    bounderies(1,nn+m) = Sysst_tmp.A(n,t)-Vary_tmp.A(n,t);
                    bounderies(2,nn+m) = Sysst_tmp.A(n,t)+Vary_tmp.A(n,t);
                end
            end
        end
    end
    if spinSys == 1
        % Fitting experimental parameters
        parameters = {'Temperature', 'mwFreq', 'ModAmp', 'mwPhase'};
        for k = 1:length(Exp)
            Exp_tmp = Exp{k};
            Expst_tmp = Expsst{k};
            for p = 1:length(parameters)
                if isfield(Vary_tmp, parameters{p})
                    sA = size(Vary_tmp.(parameters{p}));
                    if sA(1) == 1
                        if  k > 1
                            nn = nn-(sA(1)*sA(2))-1;
                        end
                        for n=1:(sA(1)*sA(2))
                            nn =nn+1;
                            startpoints(nn+m) = Exp_tmp.(parameters{p})(n);
                            bounderies(1,nn+m) = Expst_tmp.(parameters{p})(n)- ...
                                Vary_tmp.(parameters{p})(n);
                            bounderies(2,nn+m) = Expst_tmp.(parameters{p})(n) ...
                                +Vary_tmp.(parameters{p})(n);
                        end
                    elseif sA(1) > 1
                        for t=1:sA(2)
                            nn =nn+1;
                            startpoints(nn+m) = Exp_tmp.(parameters{p})(1,t);
                            bounderies(1,nn+m) = Expst_tmp.(parameters{p})(1,t) ...
                                -Vary_tmp.(parameters{p})(k,t);
                            bounderies(2,nn+m) = Expst_tmp.(parameters{p})(1,t) ...
                                +Vary_tmp.(parameters{p})(k,t);
                        end
                    end
                end
            end
        end
    end
    m = nn+m;
end
end