%Reconstruct EasySpin structures from the optimized vector
function [Sys,Exp] = generateStruc(Vary,Sys,Exp,fitparam, FitOpt)
m=0;

for s = 1:length(Vary)
    Sys_tmp = Sys{s};
    Vary_tmp = Vary{s};
    nn=0;
    parameters = {'g','gFrame','AFrame','D', 'Q','QFrame', 'DFrame', ...
        'AStrain','lwEndor','HStrain','J','ee', 'eeD', 'nn','Abund', ...
        'gStrain','DStrain', 'weight','lwpp','lw','logtcorr'};
    
    for p = 1:length(parameters)
        if isfield(Vary_tmp,parameters{p})
            sA = size(Vary_tmp.(parameters{p}));
            if sA(1) == 1
                for n=1:(sA(1)*sA(2))
                    nn =nn+1;
                    Sys_tmp.(parameters{p})(n) =fitparam(nn+m);
                end
            elseif sA(1) >1
                for n=1:(sA(1))
                    for k=1:(sA(2))
                        nn =nn+1;
                        Sys_tmp.(parameters{p})(n,k) = fitparam(nn+m);
                    end
                end
            end
        end
    end
    
    % Elaborated hyperfine couplings (identical, equivalent ...)
    if isfield(Vary_tmp,'A')
        sA = size(Vary_tmp.A);
        if sA(1) == 1 && FitOpt.sameHFcoupling == false
            for n=1:(sA(1)*sA(2))
                nn = nn+1;
                Sys_tmp.A(n)=fitparam(nn+m);
            end
        elseif  sA(1) == 1 && FitOpt.sameHFcoupling == true
            for t=1:(sA(2))
                nn = nn+1;
                Sys_tmp.A(:,t)= fitparam(nn+m);
            end
        elseif  sA(1) > 1 && FitOpt.isequivHFcoupling == true
            C = unique(FitOpt.equivHFcoupling);
            C_len = length(C);
            ts = 1;
            for n=1:C_len
                s = sum(FitOpt.equivHFcoupling(:) == n);
                for t=1:(sA(2))
                    nn = nn+1;
                    Sys_tmp.A(ts:ts+s-1,t)= fitparam(nn+m);
                end
                ts = ts+s;
            end
        elseif  sA(1) > 1  && FitOpt.isequivHFcoupling == false
            for n=1:sA(1)
                for t=1:sA(2)
                    nn = nn+1;
                    Sys_tmp.A(n,t)=fitparam(nn+m);
                end
            end
        end
    end    
    
    % Fitting experimental parameters
    if s ==1
        parameters = {'Temperature', 'mwFreq', 'ModAmp', 'mwPhase'};
        for k = 1:length(Exp)
            Exp_tmp = Exp{k};
            for p = 1:length(parameters)
                if isfield(Vary_tmp, parameters{p})
                    sA = size(Vary_tmp.(parameters{p}));
                    if sA(1) == 1
                        if  k > 1
                            nn = nn-(sA(1)*sA(2))-1;
                        end
                        for n=1:(sA(1)*sA(2))
                            nn =nn+1;
                            Exp_tmp.(parameters{p})(n) =fitparam(nn+m);
                        end
                    elseif sA(1) >1
                        for t=1:(sA(2))
                            nn =nn+1;
                            Exp_tmp.(parameters{p})(1,t) = fitparam(nn+m);
                        end
                    end
                end
            end
            Exp{k} = Exp_tmp;
        end
    end
    
    %Isotropic restriction in the fit
    Sys_tmp = restrictiso(Sys_tmp, FitOpt);
    m = nn+m;
    % Reset linw-width and rotational correlation time
    if isfield(Sys_tmp, 'logtcorr')
        if Sys{1}.logtcorr <= -13
            Sys{1}.logtcorr = -12.99;
        end
    end
    if  isfield(Sys_tmp, 'lw')
        for k=1:length(Sys{1}.lw)
            if Sys_tmp.lw(k) < 0
                Sys_tmp.lw(k) = 0;
            end
        end
    end
    if  isfield(Sys_tmp, 'lwpp')
        for k=1:length(Sys{1}.lwpp)
            if Sys_tmp.lwpp(k) < 0
                Sys_tmp.lwpp(k) = 0;
            end
        end
    end
    Sys{s} =  Sys_tmp;
    Vary{s}= Vary_tmp;
end
end