function [installed, info] = hasOptimizationToolbox()
% Check whether optimization toolbox is installed.
%
% Usage:
%   installed = hasParallelComputingToolbox()
%   [installed, info] = hasParallelComputingToolbox()
%
%   installed - boolean
%
%   info      - struct
%
% Copyright (c) 2017, Stephan Rein
% 2018

% ver returns information in struct about a given installed toolbox
% For optimization toolbox, the required string is "optim"
info = ver('optim');

% If info structure is not empty, toolbox is installed
installed = ~isempty(info);
end