function [installed, info] = hasParallelComputingToolbox()
% Check whether parallel computing toolbox is installed.
%
% Usage:
%   installed = hasParallelComputingToolbox()
%   [installed, info] = hasParallelComputingToolbox()
%
%   installed - boolean
%
%   info      - struct

% Copyright (c) 2017, Till Biskup
% Copyright (c) 2017, Stephan Rein
% 2017-04-26

% ver returns information in struct about a given installed toolbox
% For parallel computing toolbox, the required string is "parallel"
info = ver('parallel');

% If info structure is not empty, toolbox is installed
installed = ~isempty(info);

end