function FitOpt = initial_guess(Sys, Exp, Opt, FitOpt, easyspinfun, number_of_spc)

FitOpt.Int_tmp_p = cell(length(Exp),1);
FitOpt.Int_tmp = cell(number_of_spc,1);
FitOpt.Field_exp_tmp = cell(number_of_spc,1);
FitOpt.weighting = cell(number_of_spc,1);
w = cell(number_of_spc,1);

for i =1:number_of_spc
    w{i} = 1;
end
[FitOpt.Field_exp_tmp, FitOpt.Int_tmp] =  simulation_kernel(easyspinfun,Sys, Exp, FitOpt, ...
    Opt,w,number_of_spc);

for i =1:number_of_spc
    FitOpt.Frequency_exp_temporary = FitOpt.Field_exp_tmp{i};
    FitOpt.Field_exp_tmp{i} = FitOpt.Field_exp_tmp{i}(FitOpt.Field_exp_tmp{i}<FitOpt.cuttingup(i));
    FitOpt.Int_tmp{i} = FitOpt.Int_tmp{i}(1:length(FitOpt.Field_exp_tmp{i}));
    FitOpt.Intexp_tmp{i} = FitOpt.Intexp_tmp{i}(1:length(FitOpt.Field_exp_tmp{i}));
    FitOpt.Field_exp_tmp{i} = FitOpt.Field_exp_tmp{i}(FitOpt.Field_exp_tmp{i}>FitOpt.cuttingdown(i));
    FitOpt.Int_tmp{i} = FitOpt.Int_tmp{i}(end+1-length(FitOpt.Field_exp_tmp{i}):end);
    FitOpt.Intexp_tmp{i} = FitOpt.Intexp_tmp{i}(end+1-length(FitOpt.Field_exp_tmp{i}):end);
    FitOpt.Intexp_tmp{i} = transpose(FitOpt.Intexp_tmp{i});
    FitOpt.Int_tmp{i} = FitOpt.Int_tmp{i}/max(abs(FitOpt.Int_tmp{i}));
    FitOpt.Intexp_tmp{i}  = FitOpt.Intexp_tmp{i}/max(abs(FitOpt.Intexp_tmp{i}));
    FitOpt.Intexp_static = FitOpt.Intexp_tmp;
    
    %Weighting for least squares create a weighting vector with
    %length of frequency domain
    FitOpt.weighting{i} = ones(1,length(FitOpt.Field_exp_tmp{i}));
    weigthing_tmp = ones(1,length(FitOpt.Field_exp_tmp{i}));
    downarea = find(FitOpt.Field_exp_tmp{i} >  FitOpt.weighting_area_d(i),1);
    uparea = find(FitOpt.Field_exp_tmp{i} <  FitOpt.weighting_area_u(i),1,'last');
    weigthing_tmp(downarea:uparea) = FitOpt.weighting_factor(i);
    FitOpt.weighting{i} = weigthing_tmp;

    %Resphape if the vectors are transposed
    dim = size(FitOpt.Intexp_tmp{i});
    if dim(2) == 1
        FitOpt.Intexp_tmp{i} = FitOpt.Intexp_tmp{i}';
    end
    
    % Define as real
    FitOpt.Intexp_tmp{i} = real(FitOpt.Intexp_tmp{i});
    FitOpt.Int_tmp{i} = real(FitOpt.Int_tmp{i});
    FitOpt.Field_exp_tmp{i} = real(FitOpt.Field_exp_tmp{i});    
    
    %Calculate weighting
    if FitOpt.AbsScale == false
        FitOpt.Intexp_tmp{i}  = FitOpt.Intexp_tmp{i}/max(abs(FitOpt.Intexp_tmp{i}));
    end
    try
        FitOpt.Int_tmp{i} = FitOpt.Int_tmp{i}.*FitOpt.weighting{i};
        FitOpt.Intexp_tmp{i} = FitOpt.Intexp_tmp{i}.*FitOpt.weighting{i};
    catch ME
        FitOpt.Int_tmp{i} = FitOpt.Int_tmp{i}'.*FitOpt.weighting{i};
        FitOpt.Field_exp_tmp{i} = FitOpt.Field_exp_tmp{i}';
        FitOpt.Intexp_tmp{i} = FitOpt.Intexp_tmp{i}'.*FitOpt.weighting{i};
        warning(ME.identifier);
        warning('Internal transposition was necessary');
    end
end
