function [h, pk] = intial_plot(FitOpt, Frequency_exp_tmp, Intexp_tmp, number_of_spc)
h = cell(number_of_spc,1);
pk = cell(number_of_spc,1);

%PLOT (always updated, therefore kept as handel)
hFig = figure('Name','Fitting Module of SpecProFi','NumberTitle','off');
set(gcf,'PaperPositionMode','auto')
set(hFig, 'Position', [20 20 800 800])
hold on
box on
for pl =1:number_of_spc
    subplot(number_of_spc,1,pl);
    hold on
    Intexp_tmp{pl} = real(Intexp_tmp{pl});
    h{pl} = plot(Frequency_exp_tmp{pl},FitOpt.Int_tmp{pl},'r','Linewidth',1.5);
    pk{pl} = plot(Frequency_exp_tmp{pl},FitOpt.Int_tmp{pl},'color',[0 0.7 0],'linewidth',1.8);
    plot(Frequency_exp_tmp{pl}, Intexp_tmp{pl});
    axis([min(Frequency_exp_tmp{pl}) max(Frequency_exp_tmp{pl}) ...
        min(Intexp_tmp{pl})-max(abs(Intexp_tmp{pl}))/5 max(Intexp_tmp{pl})+max(abs(Intexp_tmp{pl}))/5]);
    legend('current','best');
    title(pl);
    box on
    xlabel(FitOpt.xlab{pl});
    ylabel('{\it Intensity}');
end
pause(1)