function fitparam = optimize(Sys,Vary,Exp,Opt,startpoints,bounderies,Frequency_exp,options, Intexp, FitOpt,h,...
    easyspinfun,algor,number_of_spc)


%Calling the optimization algorithms with all defined settings
try
    if algor ==0
        fitFunction = @(startpoints,B)fitsimFunction(Sys,Vary,Exp,Opt,startpoints,FitOpt,h,...
            easyspinfun,number_of_spc );
        fitparam = lsqcurvefit(fitFunction,startpoints,Frequency_exp, Intexp, bounderies(1,:),bounderies(2,:), options);
    elseif algor==1
        fitFunction = @(startpoints,B)fitsimFunction(Sys,Vary,Exp,Opt,startpoints,FitOpt,h,...
            easyspinfun,number_of_spc );
        fitparam = lsqcurvefit(fitFunction,startpoints,Frequency_exp, Intexp, [],[], options);
        
    elseif  algor ==2 || algor==3 || algor==4
        fitFunction = @(startpoints)objective_function(startpoints,Sys,Vary,Exp,Opt,FitOpt,h,easyspinfun,Intexp,...
           number_of_spc  );
        fitparam = fmincon(fitFunction,startpoints,[],[],[],[], bounderies(1,:),bounderies(2,:),[], options);
    elseif algor == 5
        fitFunction = @(startpoints)objective_function(startpoints,Sys,Vary,Exp,Opt,FitOpt,h,easyspinfun,Intexp,...
           number_of_spc);
        fitparam =  fminsearch(fitFunction,startpoints,options);
    elseif algor == 6
        FitOpt.boundaries = bounderies;
        fitFunction = @(startpoints)residual_function(startpoints,Sys,Vary,Exp,Opt,FitOpt,h,easyspinfun,Intexp,...
            number_of_spc);
        fitparam = LevMarq_SR(fitFunction, startpoints, FitOpt);
    elseif algor == 7
        FitOpt.boundaries = bounderies;
        fitFunction = @(startpoints)residual_function(startpoints,Sys,Vary,Exp,Opt,FitOpt,h,easyspinfun,Intexp,...
            number_of_spc);
        fitparam = TrustRegion_SR(fitFunction, startpoints, FitOpt);
    end
    
catch ME
   warning('Execption raised. Please Check input\n')
   fprintf(ME.identifier)
   fitparam = startpoints;
end
