function  output_Parser_struct(thestruc,fileID,name)

% Create Output information for Global_DMC
%
% Usage
%    output_Parser_struct(thestruc,fileID,name)
%
%
%
%   thestruc                           - cell array
%                                          cell array of structures
%
%   fileID                             - string
%                                          FileID
%
%   name                               - string
%                                          name of the structure
%
%
%
% Print a cell array of structures into a .txt file (parse and convert
% everything to strings) and do this in EasySpin syntax.
%
% Copyright (c) 2016, Stephan Rein
% 2017-08-26

for element = 1:length(thestruc)
    best_tmp =thestruc{element};
    if isfield(best_tmp,'tcorr')
        best_tmp.tcorr = best_tmp.tcorr*1e9;
    end
    names = fieldnames(thestruc{element});
    best_tmp_tmp= struct2cell(best_tmp);
    str_element = num2str(element);
    if element ~= 1
        Sysstring = strcat(name,str_element,'.');
    else
        Sysstring = strcat(name,'.');
    end
    for element2 = 1:length(best_tmp_tmp)
        fprintf(fileID,'%s',strcat(Sysstring , names{element2}));
        fprintf(fileID,' = ');
        size_tmp = size(best_tmp_tmp{element2,:});
        for k = 1:size_tmp(1)
            for element3=1:size_tmp(2)
                best_tmp_tmp_tmp2 =best_tmp_tmp{element2};
                if isempty(best_tmp_tmp_tmp2)
                    continue
                end
                if isnumeric(best_tmp_tmp_tmp2(element3))
                    if length(best_tmp_tmp_tmp2) > 40
                        continue
                    end
                    if (element3 == 1 && size_tmp(2) > 1 && k == 1)
                        fprintf(fileID,'[');
                    end
                    if size_tmp(1) == 1
                        fprintf(fileID,'%f', best_tmp_tmp_tmp2(element3));
                    else
                        fprintf(fileID,'%f', best_tmp_tmp_tmp2(k,element3));
                        if k ~=size_tmp(1) && element3 ~= size_tmp(2)
                            fprintf(fileID,' ');
                        end
                        if ((element3 == size_tmp(2)) && (size_tmp(1) > 1)  && k < size_tmp(1) )
                            fprintf(fileID,';');
                        end
                    end
                    if ((element3 == size_tmp(2)) && (size_tmp(2) > 1 && k == size_tmp(1)))
                        fprintf(fileID,']');
                    end
                    fprintf(fileID,'  ');
                elseif iscell(best_tmp_tmp_tmp2(element3))
                    continue
                elseif best_tmp_tmp_tmp2(element3) == true || best_tmp_tmp_tmp2(element3) == false
                    if best_tmp_tmp_tmp2(element3) == true
                        fprintf(fileID,'true');
                    else
                        fprintf(fileID,'false');
                    end
                else
                    if (element3 == 1 )
                        fprintf(fileID, '\''');
                    end
                    fprintf(fileID,'%s', best_tmp_tmp_tmp2(element3));
                    if (element3 == length(best_tmp_tmp{element2,:}))
                        fprintf(fileID, '\''');
                    end
                end
            end
        end
        fprintf(fileID,';\n');
    end
    fprintf(fileID,'\n');
end
end