function LH = parameter_sampling(FitOpt, Vary)

% Creates a Latin hypercube or a monte carlo matrix
%
% Stephan Rein, 2019

if FitOpt.LHS == true
    count = 0;
    % Check number of variables
    for nva = 1:length(Vary)
        Vary_tmp_c = Vary{nva};
        vnames = fieldnames(Vary_tmp_c);
        length(fieldnames(Vary_tmp_c));
        for ste = 1:length(fieldnames(Vary_tmp_c))
            s_tmp = size(Vary_tmp_c.(vnames{ste}));
            count = count + s_tmp(1)*s_tmp(2);
        end
        
    end
    % Call the LH function with all subfunctions
    LH = LHS(FitOpt.nTrials, count, 1, 1);
    LH = LH.*2;
    Perm = eye(FitOpt.nTrials);
    idx = randperm(FitOpt.nTrials);
    Perm = Perm(idx, :);
    %Allocation of temporay LH matrix
    LH_tmp = zeros(FitOpt.nTrials,count);
    for permutate = 1:count
        LH_tmp(:,permutate) = Perm*LH(:,permutate);
    end
    LH = LH_tmp;
    fprintf('\nLatin hypercube sampling is switched on');
    fprintf(' with permuation of sampling coordinates\n');
    fprintf('\nNumber of sampling points: %i', FitOpt.nTrials);
else
    % Check number of variables
    count = 0;
    for nva = 1:length(Vary)
        Vary_tmp_c = Vary{nva};
        vnames = fieldnames(Vary_tmp_c);
        length(fieldnames(Vary_tmp_c));
        s_tmp = size(fieldnames(Vary_tmp_c));
        for ste = 1:length(fieldnames(Vary_tmp_c))
            for ste2 = 1:s_tmp(2)
                count = count + length(Vary_tmp_c.(vnames{ste2}));
            end
        end
    end
    LH = monteCarlo(FitOpt.nTrials,count);
    LH = LH.*2;
    fprintf('\nMonte Carlo sampling is switched on\n');
    fprintf('\nNumber of sampling points: %i', FitOpt.nTrials);
end
end