function [ENDOR_sym, freq_new] = symmetrisize_ENDOR(freq, ENDOR, n, up)

if (n < min(freq) && n > max(freq))
    ENDOR_sym  = ENDOR;
else
    freq_stepsize = (max(freq)-min(freq))/(length(freq)-1);
    k = find(freq>n,1,'first');
    if up == 0
        ENDOR_part1 = ENDOR(1:1:k);
        ENDOR_part2 = ENDOR_part1(end:-1:1);
        ENDOR_sym = [ENDOR_part1;  ENDOR_part2];
        if length(ENDOR) >= length(ENDOR_sym)
            freq_new = freq(1:1:2*k);
        else
            freq_new = zeros(length(ENDOR_sym),1);
            for i=1:length(ENDOR_sym)
                freq_new(i) = min(freq)+freq_stepsize*(i-1);
            end
        end
    else
        ENDOR_part1 = ENDOR(end:-1:k+1);
        ENDOR_part2 = ENDOR_part1(end:-1:1);
        ENDOR_sym = [ENDOR_part1;  ENDOR_part2];
        if length(ENDOR) >= length(ENDOR_sym)
            freq_new = freq(end:-1:length(ENDOR)-length(ENDOR_sym)+1);
        else
               freq_new = zeros(length(ENDOR_sym),1);
            for i=1:length(ENDOR_sym)
                freq_new(i) = max(freq)-freq_stepsize*(i-1);
            end
        end
    end
end
