%Parameter sampling using LHS or Monte-Carlo
function [Sys, Exp] = varyParameters(Sys,Vary,SamplingVector,Exp, FitOpt)
nn = 0;

for tmp = 1:length(Vary)
    Sys_tmp = Sys{tmp};
    Vary_tmp = Vary{tmp};
    parameters = {'g','gFrame','AFrame','D', 'Q','QFrame', 'DFrame', ...
        'AStrain','lwEndor','HStrain','J','ee', 'eeD', 'nn','Abund', ...
        'gStrain','DStrain', 'weight','lwpp','lw','logtcorr'};
    for p = 1:length(parameters)
        if isfield(Vary_tmp,parameters{p})
            sA = size(Vary_tmp.(parameters{p}));
            if sA(1) == 1
                for n=1:(sA(1)*sA(2))
                    nn = nn+1;
                    Sys_tmp.(parameters{p})(n)= ...
                        Sys_tmp.(parameters{p})(n)- ...
                        Vary_tmp.(parameters{p})(n)+...
                        Vary_tmp.(parameters{p})(n).*SamplingVector(nn);
                end
            elseif  sA(1) > 1
                for n=1:sA(1)
                    for t=1:sA(2)
                        nn = nn+1;
                        Sys_tmp.(parameters{p})(n,t)= ...
                            Sys_tmp.(parameters{p})(n,t)-...
                            Vary_tmp.(parameters{p})(n,t)+...
                            Vary_tmp.(parameters{p})(n,t).*SamplingVector(nn);
                    end
                end
            end
        end
    end
    
    %Elaborated hyperfine couplings (identical, equivalent ...)
    if isfield(Vary_tmp,'A')
        sA = size(Vary_tmp.A);
        if sA(1) == 1 && FitOpt.sameHFcoupling == false
            for n=1:(sA(1)*sA(2))
                nn = nn+1;
                Sys_tmp.A(n)=Sys_tmp.A(n)-Vary_tmp.A(n)+...
                    Vary_tmp.A(n).*SamplingVector(nn);
            end
        elseif  sA(1) == 1 && FitOpt.sameHFcoupling == true
            for t=1:(sA(2))
                nn = nn+1;
                Sys_tmp.A(:,t)=Sys_tmp.A(1,t)-Vary_tmp.A(1,t)+...
                    Vary_tmp.A(1,t).*SamplingVector(nn);
            end
        elseif  sA(1) > 1 && FitOpt.isequivHFcoupling == true
            C = unique(FitOpt.equivHFcoupling);
            C_len = length(C);
            ts = 1;
            for n=1:C_len
                s = sum(FitOpt.equivHFcoupling(:) == n);
                for t=1:(sA(2))
                    nn = nn+1;
                    Sys_tmp.A(ts:ts+s-1,t)=Sys_tmp.A(ts:ts+s-1,t)-...
                        Vary_tmp.A(n,t)+Vary_tmp.A(n,t).*SamplingVector(nn);
                end
                ts = ts+s;
            end
        elseif  sA(1) > 1  && FitOpt.isequivHFcoupling == false
            for n=1:sA(1)
                for t=1:sA(2)
                    nn = nn+1;
                    Sys_tmp.A(n,t)=Sys_tmp.A(n,t)-Vary_tmp.A(n,t)+...
                        Vary_tmp.A(n,t).*SamplingVector(nn);
                end
            end
        end
    end
    
    % Fitting experimental parameters
    if tmp == 1
        parameters = {'Temperature', 'mwFreq', 'ModAmp', 'mwPhase'};
        for k = 1:length(Exp)
            Exp_tmp1 = Exp{k};
            for p = 1:length(parameters)
                if isfield(Vary_tmp, parameters{p})
                    sA = size(Vary_tmp.(parameters{p}));
                    if sA(1) == 1
                        if  k > 1
                            nn = nn-(sA(1)*sA(2))-1;
                        end
                        for n=1:(sA(1)*sA(2))
                            nn = nn+1;
                            Exp_tmp1.(parameters{p})(n)=Exp_tmp1.(parameters{p})(n)-...
                                Vary_tmp.(parameters{p})(n)+ ...
                                Vary_tmp.(parameters{p})(n).*SamplingVector(nn);
                        end
                    elseif  sA(1) > 1
                        for t=1:sA(2)
                            nn = nn+1;
                            Exp_tmp1.(parameters{p})(1,t)= ...
                                Exp_tmp1.(parameters{p})(1,t)- ...
                                Vary_tmp.(parameters{p})(k,t)+ ...
                                Vary_tmp.(parameters{p})(k,t).*SamplingVector(nn);
                        end
                    end
                end
            end
            Exp{k} = Exp_tmp1;
        end
    end
    Vary{tmp} = Vary_tmp;
    Sys{tmp} = Sys_tmp;
end
end
